// BanditSpiel.java                             MM 2010
import Tools.IO.*;                          // Eingaben

/**
 * Der einarmige Bandit, Spiel fuer eine Person.
 * Spieldialog mittels Konsole/Tastatur.
 *
 */
public class BanditSpielDialog
{
/**
 * Erzeugt und startet Spiel mittels Konsole/Tastatur,
 * ermoeglich Spielwiederholung.
 */
  public void starten()
  {
// Spiel einrichten
    BanditSpiel spiel = new BanditSpiel();

// Spielregeln
    System.out.println();
    System.out.println( spiel.spielRegeln());
    System.out.println();
    IOTools.readLine( "Weiter (ENTER) ");

// Spielwiederholung
    char weiter = 'j';
    do
    {
// Spiel zuruecksetzen
      spiel.reset();

// Spielen
      System.out.println();
      spielen( spiel);

// Spielauswertung
      System.out.println();
      System.out.println( spiel.auswertung());

// Weiter
      System.out.println();
      weiter = IOTools.readChar( "Noch einmal (j/n) ");
    } while( weiter == 'j');

// Beenden
    System.out.println();
    System.out.println( "Spiel beendet!");
  }

/**
 * Dialog zum Spiel,
 * gibt Spielzustand aus, verbucht Einsatz, zieht.
 * Spiel endet, wenn Bandit oder Spieler Pleite ist.
 * @param spiel aktuelle Spiel
 */
  private void spielen( BanditSpiel spiel)
  {
// Spiel
    do
    {                                   // Spielzustand
      System.out.println();
      System.out.println( spiel);

      do                                     // Einsatz
      {
        System.out.println();
        System.out.print
        ( "Dein Einsatz (Euro <= " + spiel.getHabenSpieler()
                                   + "): ");

      } while( !spiel.setEinsatz( IOTools.readInteger()));

    } while( spiel.ziehen());                       // Ziehen

// Endzustand
      System.out.println();
      System.out.println( spiel);
  }

/* ------------------------------------------------- */
                                            // Programm
/**
 * Startet das Spielprogramm.
 */
  public static void main( String[] args)
  {
// Spieldialog einrichten
    BanditSpielDialog spielDialog = new BanditSpielDialog();

// Spieldialog starten
    spielDialog.starten();
  }
}
