// Konto.java                                   MM 2009

/**
 * Kontoverwaltung:
 * Vorhandenes Kapital (Euro), kontrolliertes Verbuchen.
 */
public class Konto
{
/* ------------------------------------------------- */
                                            // Attribut
/**
 * Vorhandenes Kapital in Euro.
 */
  private int haben;

/* ------------------------------------------------- */
                                       // Konstruktoren
/**
 * Konstruktor, legt leeres Konto an.
 */
  public Konto()
  {
    haben = 0;
  }

/**
 * Konstruktor, legt Konto an.
 * @param euro Startkapital
 */
  public Konto( int euro)
  {
    this();
    if( euro > 0) haben = euro;
  }

/* ------------------------------------------------- */
                                    // toString-Methode
/**
 * Darstellen des Kontostandes.
 * @return Haben als String
 */
  public String toString()
  {
    return "Haben " + haben;
  }

/* ------------------------------------------------- */
                                         // get-Methode
/**
 * Liest aktuelles Haben.
 * @return Haben
 */
  public int getHaben()
  {
    return haben;
  }

/* ------------------------------------------------- */
                                    // service-Methoden
/**
 * Verbuchen eines Betrags in Euro.
 * @param euro Betrag (<0 abheben, >0 gutschreiben)
 * @return true, falls Buchung mglich
 */
  public boolean verbuchen( int euro)
  {
    if( haben + euro < 0) return false;
    haben += euro;
    return true;
  }

/**
 * Konto leer, der Kunde ist Pleite.
 * @return true, falls Konto leer
 */
  public boolean istPleite()
  {
    if( haben > 0) return false;
    return true;
  }

/* ------------------------------------------------- */
                                        // Testprogramm
/**
 * Test der Klasse Konto,
 * richtet Konto ein, schreibt Betrag gut
 * und hebt ab, solange es moeglich ist.
 */
  public static void main( String[] args)
  {
// Spielerkonto einrichten
    Konto kunde = new Konto( 300);
    System.out.println( kunde);

// Gutschreiben
    System.out.println( "+ 150 Euro");
    kunde.verbuchen( 150);

// Abheben, bis Verbuchung nicht mehr moeglich
    do
    {
      System.out.println( kunde);
      System.out.println( "- 100 Euro");
    } while( kunde.verbuchen( -100));
    System.out.println( kunde);

// Beenden
    System.out.println();
    System.out.println( "Test beendet!");
  }
}
